# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define section free

%if 0
%define reltag _redhat_1
%define namedreltag -redhat-1
%endif
%global namedversion %{version}%{?namedreltag}

Name:           svnkit
Version:        1.3.5
Release:        4%{?reltag}%{?dist}
Epoch:          0
Summary:        Pure Java Subversion client library
License:        BSD
Group:          Development/Java
URL:            http://www.svnkit.com/
# svn -q export http://svn.svnkit.com/repos/svnkit/tags/1.3.5/ svnkit-1.3.5 && tar cjf svnkit-1.3.5.tar.bz2 svnkit-1.3.5
Source0:        svnkit-1.3.5.tar.bz2
Source10:       svnkit-jsvn-script
Source20:       svnkit-jsvnadmin-script
Source30:       svnkit-jsvnlook-script
Source40:       svnkit-jsvnsync-script
Patch0:         svnkit-build.patch
Patch1:         svnkit-pom-groups.patch
Patch2:         svnkit-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       jna >= 0:3.2.7
Requires:       sqljet >= 0:1.0.4
%if 0
Requires:       svn-javahl
%endif
Requires:       trilead-ssh2 >= 0:213
BuildRequires:  ant
BuildRequires:  jna >= 0:3.2.7
BuildRequires:  junit
BuildRequires:  maven-ant-tasks
BuildRequires:  sqljet >= 0:1.0.4
%if 0
BuildRequires:  svn-javahl
%endif
BuildRequires:  trilead-ssh2 >= 0:213
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Use SVNKit for
- Subversion clients and IDE integrations
  SVNKit supports all standard Subversion operations, both
  on working copies and repository. It is compatible with all
  versions of Subversion, works over HTTP, SSH, SVN and
  FILE protocols.
- Arbitrary object model versioning
  SVNKit provides API to version virtually any object model
  with standard Subversion repository; there is no need to
  keep anything in the filesystem.
- Server side applications
  SVNKit works with local repositories as well as with remote
  ones - your web application will benefit from direct access
  to repository and will grind data stored in repository in
  the way you need it.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%if 0
%patch2 -p1 -b .sav2
%endif

pushd contrib
%if 0
# FIXME: (dwalluck): removing javahl and jna could result in native dependencies that we don't want
%{__rm} -r javahl/src/*
%{__ln_s} $(build-classpath svn-javahl) javahl/javahl.jar
%endif
%{__rm} -r jna/*.jar
%{__ln_s} $(build-classpath jna) jna/jna.jar
%{__rm} -r maven/*.jar
%{__ln_s} $(build-classpath maven-ant-tasks) maven/maven-ant-tasks-2.0.10.jar
%if 0
# FIXME: (dwalluck): where does this come from?
%{__rm} -r sequence/*
%endif
%{__rm} -r trilead/*.jar
%{__ln_s} $(build-classpath trilead-ssh2) trilead/trilead.jar
%{__rm} -r junit/*.jar
%{__ln_s} $(build-classpath junit) junit/junit.jar
%{__rm} -r sqljet/*.jar
%{__ln_s} $(build-classpath sqljet) sqljet/sqljet.jar
%{__ln_s} $(build-classpath antlr3-runtime) sqljet/antlr-runtime-3.1.3.jar
popd

%build
export OPT_JAR_LIST=:
export CLASSPATH=
%{ant} -Dbuild.sysclasspath=first deploy-maven

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p build/lib/svnkit-cli.jar %{buildroot}%{_javadir}/svnkit-cli-%{namedversion}.jar

pushd build/maven-deploy/m2repo
# jars
%{__cp} -p org/tmatesoft/svnkit/svnkit/%{namedversion}/svnkit-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/svnkit-%{namedversion}-javadoc.jar
%{__cp} -p org/tmatesoft/svnkit/svnkit/%{namedversion}/svnkit-%{namedversion}-sources.jar %{buildroot}%{_javadir}/svnkit-%{namedversion}-sources.jar
%{__cp} -p org/tmatesoft/svnkit/svnkit/%{namedversion}/svnkit-%{namedversion}.jar %{buildroot}%{_javadir}/svnkit-%{namedversion}.jar
%{__cp} -p org/tmatesoft/svnkit/svnkit-javahl/%{namedversion}/svnkit-javahl-%{namedversion}-sources.jar %{buildroot}%{_javadir}/svnkit-javahl-%{namedversion}-sources.jar
%{__cp} -p org/tmatesoft/svnkit/svnkit-javahl/%{namedversion}/svnkit-javahl-%{namedversion}.jar %{buildroot}%{_javadir}/svnkit-javahl-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/tmatesoft/svnkit/svnkit/%{namedversion}/svnkit-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-svnkit.pom
%{__cp} -p org/tmatesoft/svnkit/svnkit-javahl/%{namedversion}/svnkit-javahl-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-svnkit-javahl.pom
popd

# depmaps
%add_to_maven_depmap org.tmatesoft.svnkit svnkit %{namedversion} JPP svnkit
%add_to_maven_depmap org.tmatesoft.svnkit svnkit-javahl %{namedversion} JPP svnkit-javahl

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr build/doc/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%{__mkdir} %{buildroot}%{_bindir}
%{__cp} -p %{SOURCE10} %{buildroot}%{_bindir}/jsvn
%{__cp} -p %{SOURCE20} %{buildroot}%{_bindir}/jsvnadmin
%{__cp} -p %{SOURCE30} %{buildroot}%{_bindir}/jsvnlook
%{__cp} -p %{SOURCE40} %{buildroot}%{_bindir}/jsvnsync

%if %with repolib
# repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr build/maven-deploy/m2repo/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc build/lib/{README.txt,SEQUENCE-LICENSE,changelog.txt} doc/examples
%attr(0755,root,root) %{_bindir}/jsvn
%attr(0755,root,root) %{_bindir}/jsvnadmin
%attr(0755,root,root) %{_bindir}/jsvnlook
%attr(0755,root,root) %{_bindir}/jsvnsync
%{_javadir}*/svnkit-%{namedversion}-javadoc.jar
%{_javadir}*/svnkit-javadoc.jar
%{_javadir}*/svnkit-%{namedversion}-sources.jar
%{_javadir}*/svnkit-sources.jar
%{_javadir}*/svnkit-%{namedversion}.jar
%{_javadir}*/svnkit.jar
%{_javadir}*/svnkit-cli.jar
%{_javadir}*/svnkit-cli-%{namedversion}.jar
%{_javadir}*/svnkit-javahl-%{namedversion}-sources.jar
%{_javadir}*/svnkit-javahl-sources.jar
%{_javadir}*/svnkit-javahl-%{namedversion}.jar
%{_javadir}*/svnkit-javahl.jar
%{_datadir}/maven2/poms/JPP-svnkit.pom
%{_datadir}/maven2/poms/JPP-svnkit-javahl.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Dec 06 2011 David Walluck <dwalluck@redhat.com> 0:1.3.5-4
- add sqljet >= 1.0.4 requirement
- use upstream groupId for trilead-ssh2 (JPP ver contains svnkit patch)

* Mon Dec 05 2011 David Walluck <dwalluck@redhat.com> 0:1.3.5-3
- add repolib
- add pom patch (for redhat)

* Thu Nov 10 2011 David Walluck <dwalluck@redhat.com> 0:1.3.5-2
- clean up some unused files

* Thu Oct 20 2011 David Walluck <dwalluck@redhat.com> 0:1.3.5-1
- 1.3.5

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 1.3.0-3
- Auto rebuild for JPackage 6 in centos5 mock

* Wed Jul 15 2009 David Walluck <dwalluck@redhat.com> 0:1.3.0-2
- Requires: trilead-ssh2

* Tue Jul 14 2009 David Walluck <dwalluck@redhat.com> 0:1.3.0-1
- 1.3.0
- use external svn-javahl
- add poms

* Wed Jun 17 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.4-1.jpp5
- first release
